/*global fetch*/
"use strict";
(function(){
    
    function $(id){ return document.getElementById(id) }
    function qs(selector){ return document.querySelector(selector) }
    function qsa(selector){ return document.querySelectorAll(selector) }
    
    window.onload = function(){
        $("ajaxbtn").onclick = callAjax;
    };
    
    //include this code, based on: https://developers.google.com/web/updates/2015/03/introduction-to-fetch
    function checkStatus(response) {  
        if (response.status >= 200 && response.status < 300) {  
            return response.text();
        } else {  
            return Promise.reject(new Error(response.status+": "+response.statusText)); 
        } 
    }
     
    // event handler for clicking the ajax button   
    function callAjax(){
        //get the url from the text input
        let url = $("urltext").value;
        
        // dispaly loading text and disable button while ajax call is loading
        $("response").innerHTML = "Loading...";
        $("ajaxbtn").disabled = true;
        
        //start ajax call
        fetch(url, {credentials: 'include'}) // include credentials for cloud9
           .then(checkStatus)
           .then(function(responseText) {
                // ajax call succeded! place text and re-enable the button
                $("response").innerHTML = responseText;
                $("ajaxbtn").disabled = false;
            })
           .catch(function(error) {
               // ajax call failed! alert, place text and re-enable the button
               $("response").innerHTML = "THERE WAS AN ERROR!";
               alert(error);
               $("ajaxbtn").disabled = false;
           });
    }
    
})();